<?php
/*
  @author PayNetEasy.com modules
*/

  class payneteasy {
    var $code, $title, $description, $enabled;

// class constructor
    function payneteasy() {
      global $order;

      $this->signature = 'payneteasy|payneteasy|1.0';
      $this->api_version = '3.0-2';

      $this->code = 'payneteasy';
      $this->title = MODULE_PAYMENT_PAYNETEASY_TEXT_TITLE;
      $this->public_title = MODULE_PAYMENT_PAYNETEASY_TEXT_PUBLIC_TITLE;
      $this->description = MODULE_PAYMENT_PAYNETEASY_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_PAYNETEASY_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_PAYNETEASY_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_PAYNETEASY_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_PAYNETEASY_ORDER_STATUS_ID;
      }
      
      if (is_object($order)) $this->update_status();
    }

// class methods
    function update_status() {
      global $order;
      return true;
    }

    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->public_title);
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      global $order;

      for ($i=1; $i<13; $i++) {
        $expires_month[] = array('id' => sprintf('%02d', $i), 'text' => strftime('%B',mktime(0,0,0,$i,1,2000)));
      }

      $today = getdate(); 
      for ($i=$today['year']; $i < $today['year']+10; $i++) {
        $expires_year[] = array('id' => strftime('%y',mktime(0,0,0,1,1,$i)), 'text' => strftime('%Y',mktime(0,0,0,1,1,$i)));
      }

      $confirmation = array('fields' => array(array('title' => MODULE_PAYMENT_PAYNETEASY_CREDIT_CARD_OWNER,
                                                    'field' => tep_draw_input_field('cc_owner', $order->billing['firstname'] . ' ' . $order->billing['lastname'])),
                                              array('title' => MODULE_PAYMENT_PAYNETEASY_CREDIT_CARD_NUMBER,
                                                    'field' => tep_draw_input_field('cc_number_nh-dns')),
                                              array('title' => MODULE_PAYMENT_PAYNETEASY_CREDIT_CARD_EXPIRES,
                                                    'field' => tep_draw_pull_down_menu('cc_expires_month', $expires_month) . '&nbsp;' . tep_draw_pull_down_menu('cc_expires_year', $expires_year)),
                                              array('title' => MODULE_PAYMENT_PAYNETEASY_CREDIT_CARD_CVC,
                                                    'field' => tep_draw_input_field('cc_cvc_nh-dns', '', 'size="5" maxlength="4"'))));

      return $confirmation;
    }

    function process_button() {
      return false;
    }

    function before_process() {
      global $HTTP_POST_VARS, $customer_id, $order, $sendto, $currency;
      if(isset($_POST['orderid']) && isset($_POST['merchant_order']) ){
        $payneteasy_3dsec_time = (int) $_SESSION['PAYNETEASY_3DSEC_TIME'];
        unset($_SESSION['PAYNETEASY_3DSEC_TIME']);
        tep_session_unregister("PAYNETEASY_3DSEC_TIME");
        if($_POST['status']=='approved' && ( (time() - $payneteasy_3dsec_time)<=600 )){
            return true;
        }
        else{
            $url = tep_href_link(FILENAME_CHECKOUT_PAYMENT,'payment_error='.$this->code.'&error='.urlencode($_POST['status']).'', 'SSL');
            $url = str_replace("&amp;","&",$url);
            header("Location: ".$url);
            exit;
        }
      }
      $order_id = rand(999,99999999999);
      $description = '';
      foreach($order->products as $k=>$v)
      {
        $description .= $v['name'].';';
      }
      $description = substr($description,0,-1);
      $total = (float) $this->format_raw($order->info['total']);
      $total = $total * 100;
      $total_in_cents = (int) $total;
      $endpoint = substr(MODULE_PAYMENT_PAYNETEASY_TRANSACTION_URL,strrpos(MODULE_PAYMENT_PAYNETEASY_TRANSACTION_URL,'/')+1);
      $control = sha1($endpoint.$order_id.$total_in_cents.$order -> customer['email_address'].MODULE_PAYMENT_PAYNETEASY_CONTROL_KEY);
      $params = array(
                      'client_orderid'=>$order_id,
                      'order_desc'=>substr($description,0,125),
                      'card_printed_name'=>substr($_POST['cc_owner'],0,128),
                      'first_name' => substr($order->billing['firstname'],0,50),
                      'last_name' => substr($order->billing['lastname'],0,50),
                      'address1' => substr($order->billing['street_address'],0,50),
                      'city' => substr($order->billing['city'],0,50),
                      'zip_code' => substr($order -> customer['postcode'],0,10),
                      'country' => substr($order -> customer['country']['iso_code_2'],0,2),
                      'phone' => substr($order -> customer['telephone'],0,15),
                      'email' => substr($order -> customer['email_address'],0,50),
                      'amount' => substr($this->format_raw($order->info['total']), 0, 10),
                      'currency' => substr($currency, 0, 3),
                      'credit_card_number' => substr($HTTP_POST_VARS['cc_number_nh-dns'], 0, 20),
                      'expire_month' => $HTTP_POST_VARS['cc_expires_month'],
                      'expire_year' => $HTTP_POST_VARS['cc_expires_year'],
                      'cvv2' => substr($HTTP_POST_VARS['cc_cvc_nh-dns'],0,4),
                      'ipaddress' => $_SERVER['REMOTE_ADDR'],
                      'control' => $control,
                      'redirect_url' => 'http://'.$_SERVER['HTTP_HOST'].'/checkout_process.php'
                      );

      $post_string = '';

      foreach ($params as $key => $value) {
        $post_string .= $key . '=' . urlencode(trim($value)) . '&';
      }
      
      $post_string = substr($post_string, 0, -1);
      
      $transaction_response = $this->sendTransactionToGateway(MODULE_PAYMENT_PAYNETEASY_TRANSACTION_URL, $post_string);
      $error = false;
      $response = array();
      if(!empty($transaction_response)){
        $res = explode("&",$transaction_response);
        if(count($res)>0){
            foreach($res as $v)
            {
                $arr_tmp = explode("=",$v);
                if(count($arr_tmp)==2){
                    $response[trim($arr_tmp[0])] = trim($arr_tmp[1]);
                }
            }
        }
      }
      else{
        $error = 'Response error. Please try again later.';
      }
      if($error == false){
        if($response['type'] == 'validation-error'){
            $error = str_replace(array('_','+'),' ',$response['error-message']);
        }
      }
      if($error == false){
        // get order status
        $control = sha1(MODULE_PAYMENT_PAYNETEASY_MERCHANT_LOGIN.$response['merchant-order-id'].$response['paynet-order-id'].MODULE_PAYMENT_PAYNETEASY_CONTROL_KEY);
        $params = array();
        $params['login'] = MODULE_PAYMENT_PAYNETEASY_MERCHANT_LOGIN;
        $params['client_orderid'] = $response['merchant-order-id'];
        $params['orderid'] = $response['paynet-order-id'];
        $params['control'] = $control;
        $post_string = '';
        foreach ($params as $key => $value) {
            $post_string .= $key . '=' . urlencode(trim($value)) . '&';
        }

        $post_string = substr($post_string, 0, -1);
        $status_url = str_replace("/sale/","/status/",MODULE_PAYMENT_PAYNETEASY_TRANSACTION_URL);
        $i = 0;
        $j = 60;
        while($i<$j)
        {
            //@$ob_start();            
            $transaction_response = $this->sendTransactionToGateway($status_url, $post_string);
            //echo "<pre>".$status_url; var_dump($response); var_dump($post_string); var_dump($transaction_response); exit;
            $response = array();
            if(!empty($transaction_response)){
                $res = explode("&",$transaction_response);
                if(count($res)>0){
                    foreach($res as $v)
                    {
                        $arr_tmp = explode("=",$v);
                        if(count($arr_tmp)==2){
                            $response[trim($arr_tmp[0])] = trim($arr_tmp[1]);
                            if(isset($response['status']) && $response['status'] == "approved"){
                                return true;
                            }
                            if(isset($response['html'])){
                                // 3d sec
                                $response['html'] = urldecode($response['html']);
                                tep_session_register('PAYNETEASY_3DSEC_TIME');
                                $_SESSION['PAYNETEASY_3DSEC_TIME'] = time();
                                echo $response['html'];
                                exit;
                            }
                        }
                    }
                }
            }
            else{
                $error = 'Response error. Please try again later.';
            }
            //@flush(); @ob_flush(); @ob_end_flush();
            sleep(1);
            $i++;
        }
        if($i==$j){
            if(!isset($response['status'])) $response['status']  = 'undefined';
            $error = 'Response status: '.$response['status'].'.';
        }
        if( $error == false || isset($response['type']) ){
            if($response['type'] == 'validation-error'){
                $error = str_replace(array('_','+'),' ',$response['error-message']);
            }
        }
      }

      if ( $error!=false || !isset($response['type']) ) {
        $url = tep_href_link(FILENAME_CHECKOUT_PAYMENT,'payment_error='.$this->code.'&error='.urlencode($error).'', 'SSL');
        $url = str_replace("&amp;","&",$url);
        header("Location: ".$url);
        exit;
      }
    }

    function after_process() {
      // call directly after button click before calling before_process()
      return false;
    }

    function get_error() {
      global $HTTP_GET_VARS;
      if( $HTTP_GET_VARS['error'] == null ) $HTTP_GET_VARS['error'] = "Connection problems with the payment server. Please try later.";
      $error_message = urldecode($HTTP_GET_VARS['error']);
      
      $error = array('title' => MODULE_PAYMENT_PAYNETEASY_ERROR_TITLE,
                     'error' => $error_message);

      return $error;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PAYNETEASY_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
        $res = tep_db_query("select max(orders_status_id) as status_id from " . TABLE_ORDERS_STATUS);
        if(tep_db_num_rows($res)>=1){
            $status = tep_db_fetch_array($res);
            $status_id = $status['status_id']+1;
        }
        else{
           $status_id = 1; 
        }
        $languages = tep_get_languages();
        for ($i=0, $n=sizeof($languages); $i<$n; $i++) {
          tep_db_query("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name, public_flag, downloads_flag) values ('" . $status_id . "', '" . $languages[$i]['id'] . "', 'Approved [PaymentEasy]', '1', '1')");
        }

        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable PaymentEasy Payment Gateway', 'MODULE_PAYMENT_PAYNETEASY_STATUS', 'False', 'Do you want to accept PaymentEasy payments?', '6', '0', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Control Key', 'MODULE_PAYMENT_PAYNETEASY_CONTROL_KEY', '', 'Control key', '6', '0', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Payment URL', 'MODULE_PAYMENT_PAYNETEASY_TRANSACTION_URL', '', 'Transaction url', '6', '0', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Merchant Login', 'MODULE_PAYMENT_PAYNETEASY_MERCHANT_LOGIN', '', 'Merchant login name', '6', '0', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_PAYNETEASY_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
      tep_db_query("delete from ". TABLE_ORDERS_STATUS ." WHERE orders_status_name='Approved [PaymentEasy]' ");
    }

    function keys() {
      return array( 'MODULE_PAYMENT_PAYNETEASY_STATUS',
                    'MODULE_PAYMENT_PAYNETEASY_CONTROL_KEY', 
                    'MODULE_PAYMENT_PAYNETEASY_TRANSACTION_URL',
                    'MODULE_PAYMENT_PAYNETEASY_MERCHANT_LOGIN',
                    'MODULE_PAYMENT_PAYNETEASY_ORDER_STATUS_ID'
                    );
    }

    function sendTransactionToGateway($url, $parameters) {
      $server = parse_url($url);

      if (isset($server['port']) === false) {
        $server['port'] = ($server['scheme'] == 'https') ? 443 : 80;
      }

      if (isset($server['path']) === false) {
        $server['path'] = '/';
      }

      if (isset($server['user']) && isset($server['pass'])) {
        $header[] = 'Authorization: Basic ' . base64_encode($server['user'] . ':' . $server['pass']);
      }

      if (function_exists('curl_init')) {
        $curl = curl_init($server['scheme'] . '://' . $server['host'] . $server['path'] . (isset($server['query']) ? '?' . $server['query'] : ''));
        curl_setopt($curl, CURLOPT_PORT, $server['port']);
        curl_setopt($curl, CURLOPT_HEADER, 0);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
        curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $parameters);

        $result = curl_exec($curl);

        curl_close($curl);
      } else {
        $result = false;
      }

      return $result;
    }
    
    function format_raw($number, $currency_code = '', $currency_value = '') {
      global $currencies, $currency;

      if (empty($currency_code) || !$this->is_set($currency_code)) {
        $currency_code = $currency;
      }

      if (empty($currency_value) || !is_numeric($currency_value)) {
        $currency_value = $currencies->currencies[$currency_code]['value'];
      }

      return number_format(tep_round($number * $currency_value, $currencies->currencies[$currency_code]['decimal_places']), $currencies->currencies[$currency_code]['decimal_places'], '.', '');
    }
  }
?>
